"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
function createConsumer(Consumer, context) {
    /**
     * SrimerConsumer.
     */
    return /** @class */ (function (_super) {
        tslib_1.__extends(SrimmerConsumer, _super);
        /**
         * initialize bitmask.
         */
        function SrimmerConsumer(props) {
            var _this = _super.call(this, props) || this;
            /**
             * select and versioning.
             */
            _this.select = function (state) {
                var bitState = context.getBitState(_this.props.select);
                bitState.state = bitState.state || _this.props.select(state);
                return (react_1.default.createElement(Versioning, { version: bitState.version }, function () { return _this.props.children(bitState.state); }));
            };
            context.register(props.select);
            return _this;
        }
        /**
         * rednder.
         */
        SrimmerConsumer.prototype.render = function () {
            return react_1.default.createElement(Consumer, null, this.select);
        };
        return SrimmerConsumer;
    }(react_1.default.Component));
}
exports.createConsumer = createConsumer;
/**
 * Versioning selected state to avoid re-rendering.
 */
var Versioning = /** @class */ (function (_super) {
    tslib_1.__extends(Versioning, _super);
    function Versioning() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Versioning.prototype.shouldComponentUpdate = function (props) {
        return this.props.version !== props.version;
    };
    Versioning.prototype.render = function () {
        return this.props.children();
    };
    return Versioning;
}(react_1.default.Component));
//# sourceMappingURL=Consumer.js.map