import React from "react";
export function createConsumer(Consumer, context) {
    /**
     * SrimerConsumer.
     */
    return class SrimmerConsumer extends React.Component {
        /**
         * initialize bitmask.
         */
        constructor(props) {
            super(props);
            /**
             * select and versioning.
             */
            this.select = (state) => {
                const bitState = context.getBitState(this.props.select);
                bitState.state = bitState.state || this.props.select(state);
                return (React.createElement(Versioning, { version: bitState.version }, () => this.props.children(bitState.state)));
            };
            context.register(props.select);
        }
        /**
         * rednder.
         */
        render() {
            return React.createElement(Consumer, null, this.select);
        }
    };
}
/**
 * Versioning selected state to avoid re-rendering.
 */
class Versioning extends React.Component {
    shouldComponentUpdate(props) {
        return this.props.version !== props.version;
    }
    render() {
        return this.props.children();
    }
}
//# sourceMappingURL=Consumer.js.map