import React from "react";
import { Update, Select } from "./Context";
export declare function define<State extends object>(): {
    Provider: {
        new (props: import("./Provider").ProviderProps<State>): {
            render(): JSX.Element;
            getState: () => State;
            updateState: (update: Update<State>) => void;
            setState<K extends "state">(state: import("./Provider").ProviderState<State> | ((prevState: Readonly<import("./Provider").ProviderState<State>>, props: Readonly<import("./Provider").ProviderProps<State>>) => import("./Provider").ProviderState<State> | Pick<import("./Provider").ProviderState<State>, K> | null) | Pick<import("./Provider").ProviderState<State>, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callBack?: (() => void) | undefined): void;
            readonly props: Readonly<{
                children?: React.ReactNode;
            }> & Readonly<import("./Provider").ProviderProps<State>>;
            state: Readonly<import("./Provider").ProviderState<State>>;
            context: any;
            refs: {
                [key: string]: React.ReactInstance;
            };
        };
    };
    Consumer: {
        new <T>(props: import("./Consumer").ConsumerProps<State, any>): {
            render(): JSX.Element;
            select: (state: State) => JSX.Element;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./Consumer").ConsumerProps<State, T>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callBack?: (() => void) | undefined): void;
            readonly props: Readonly<{
                children?: React.ReactNode;
            }> & Readonly<import("./Consumer").ConsumerProps<State, T>>;
            state: Readonly<{}>;
            context: any;
            refs: {
                [key: string]: React.ReactInstance;
            };
        };
    };
    get: () => State | undefined;
    select: <T>(select: Select<State, T>) => (props: {
        children: (s: T) => React.ReactNode;
    }) => JSX.Element;
    update: (update: Update<State>) => void;
};
