import React from "react";
import { Context } from "./Context";
import { createConsumer } from "./Consumer";
import { createProvider } from "./Provider";
export function define() {
    const context = new Context();
    const { Provider, Consumer } = React.createContext({}, (_, next) => context.calculateBitmask(next));
    const SrimmerProvider = createProvider(Provider, context);
    const SrimmerConsumer = createConsumer(Consumer, context);
    return {
        Provider: SrimmerProvider,
        Consumer: SrimmerConsumer,
        get: () => {
            return context.getState && context.getState();
        },
        select: function select(select) {
            return (props) => (React.createElement(SrimmerConsumer, { select: select }, props.children));
        },
        update: (update) => {
            context.updateState && context.updateState(update);
        }
    };
}
//# sourceMappingURL=index.js.map